#!/bin/sh
# i18n.sh - i18n support on XkbdConfigurationManager
# 11jul09 by Masaki Shinomiya <shino@pos.to>
#w482 Loc_updating_menu, Loc_updating_flicker, Loc_updating_help

### xkbdconfig.mo
## XkbConfigMngr
_Title="Xkb Config Manager"
_Error="An Error has occured. Try again."
_Success="Changes applied successfuly."
_Information="Information"
_Intro="This tool lets you modify the keyboard settings part of your xorg.conf file."
_only_Xorg="Note that this is only relevant for Xorg users..."
_Main="Main"
_Options="Options"
_Keyboard_Model="Keyboard Model"
_Layouts="Layouts"
_Layout_Variants="Layout Variants"
_Shift_Lock="Group Shift/Lock behavior"
_Third="Third level choosers"
_Control="Control key position"
_LED="Use keyboard LED to show alternative group"
_CapsLock="CapsLock key behavior"
_Alt_Win="Alt/Win key behavior"
_Compose="Compose key position"
_EuroSign="Adding the EuroSign to certain keys"
_activate="Click 'Yes' to activate the new settings"
_restart="...else they will apply when you restart X            "
_Exit="Exit"

## XkbLayoutConfig
_no_XkbLayout="Your xorg.conf file does not contain any XkbLayout options!"
_Change="Change"
_Add="Add"
_add_change="What would you like to do:
add another layout or change the current one"
_layout_replace="Please select the layout you would like to
 replace it with, then press OK"
_layout_add="Please select the layout you would like to
 add, then press OK"
_remove_add="If you wish to remove one of the above, select
 it in the list below, then press OK.
To add an additional layout, select it and press OK."
_current_layout="You are currently using the following layout(s):"
_No_more="Sorry! No more than 4 layouts are allowed..."

## XkbModelConfig
_no_XkbModel="Your xorg.conf file does not contain any XkbModel options!"
_models="Here is a list of all the keyboard models available.
The model you are currently using is:"
_replace_model="To replace it, please select one and press OK
To keep the current model, press cancel..."

##XkbOptionsAltwin
_cuuremt_altwin="You are currently using the following altwin setting:"
_To_change="To change it, select a new one below, then press OK.
To remove it, select it below and press OK.
To abort press cancel."
_select_setting="Please select the setting you would like to use, then press OK.
To abort, press cancel."
_Menu_key="Add the standard behavior to Menu key."
_Alt_keys="Alt and Meta are on the Alt keys (default)."
_Win_keys="Meta is mapped to the Win-keys."
_left_Win_key="Meta is mapped to the left Win-key."
_Super="Super is mapped to the Win-keys (default)." 
_Hyper="Hyper is mapped to the Win-keys."
_Super_to_Menu="Alt is mapped to the right Win-key and Super to Menu."

##XkbOptionsCaps
_current_caps="You are currently using the following caps setting:"
_internal="CapsLock uses internal capitalization. Shift cancels CapsLock."
_internal_nocancel="CapsLock uses internal capitalization. Shift doesn't cancel CapsLock."
_shift="CapsLock acts as Shift with locking. Shift cancels CapsLock."
_shift_nocancel="CapsLock acts as Shift with locking. Shift doesn't cancel CapsLock."
_shift_lock="CapsLock just locks the Shift modifier." 
_capslock="CapsLock toggles normal capitalization of alphabetic characters." 
_shiftlock="CapsLock toggles Shift so all keys are affected."

## XkbOptionsCompose
_current_compose="You are currently using the following compose setting:"
_ralt="Right Alt is Compose."
_rwin="Right Win-key is Compose."
_menu="Menu is Compose."
_rctrl="Right Ctrl is Compose."

## XkbOptionsCtrl
_current_Control="You are currently using the following Control key setting:"
_nocaps="Make CapsLock an additional Control."
_swapcaps="Swap Control and CapsLock."
_ctrl_ac="Control key at left of 'A'"
_ctrl_aa="Control key at bottom left"
_ctrl_ra="Right Control key works as Right Alt."

## XkbOptionsEuro
_current_Euro="You are currently using the following Eurosign setting:"
_need_Third="Note: to use the EuroSign you will need
a \"$_Third\". "
_e="Add the EuroSign to the E key."
_5="Add the EuroSign to the 5 key."
_2="Add the EuroSign to the 2 key."

## XkbOptionsGrp
_current_group="You are currently using the following group setting:"
_switch="R-Alt switches group while pressed."
_lswitch="Left Alt key switches group while pressed."
_lwin_switch="Left Win-key switches group while pressed."
_rwin_switch="Right Win-key switches group while pressed."
_win_switch="Both Win-keys switch group while pressed."
_rctrl_switch="Right Ctrl key switches group while pressed."
_toggle="Right Alt key changes group."
_lalt_toggle="Left Alt key changes group."
_caps_toggle="CapsLock key changes group."
_shift_caps_toggle="Shift+CapsLock changes group."
_shifts_toggle="Both Shift keys together change group."
_alts_toggle="Both Alt keys together change group."
_ctrls_toggle="Both Ctrl keys together change group."
_ctrl_shift_toggle="Control+Shift changes group."
_ctrl_alt_toggle="Alt+Control changes group."
_alt_shift_toggle="Alt+Shift changes group."
_menu_toggle="Menu key changes group."
_lwin_toggle="Left Win-key changes group."
_rwin_toggle="Right Win-key changes group."
_lshift_toggle="Left Shift key changes group."
_rshift_toggle="Right Shift key changes group."
_lctrl_toggle="Left Ctrl key changes group."
_rctrl_toggle="Right Ctrl key changes group."

## XkbOptionsGrp_led
_current_LED="You are currently using the following LED setting:"
_num="NumLock LED shows alternative group."
_caps="CapsLock LED shows alternative group."
_scroll="ScrollLock LED shows alternative group."

## XkbOptionsLv3
_current_Third="You are currently using the following Third Level settings:"
_3switch="Press Right Control to choose 3rd level."
_3menu_switch="Press Menu key to choose 3rd level."
_3win_switch="Press any of Win-keys to choose 3rd level."
_3lwin_switch="Press Left Win-key to choose 3rd level."
_3rwin_switch="Press Right Win-key to choose 3rd level."
_3alt_switch="Press any of Alt keys to choose 3rd level."
_3lalt_switch="Press Left Alt key to choose 3rd level."
_3ralt_switch="Press Right Alt key to choose 3rd level."

## XkbVariantConfig
_current_variants="You are currently using the following variants:"
_To_remove_variant="To remove a variant, select it in the list below and press OK.
To add a new one, select it and press OK.

NOTE: if you select a variant for a layout that already has one,
 the new one will replace the old."
_select_variant="Please select the variant you would like to add, then press OK."
 
### end of xkbdconfig.mo

mo=xkbdconfig.mo
# set locale
for lng in C $(echo $LANGUAGE|cut -d':' -f1) $LC_ALL $LANG;do :;done   # ex.    ja_JP.UTF-8
# search locale file
lng1=$(echo $lng|cut -d'.' -f1)      # ex.   ja_JP
lng2=$(echo $lng|cut -d'_' -f1)   # ex.   ja
LOCALEDIR=/usr/share/locale
[ "$mo" ] || mo=$(basename $0).mo
for D in C en $lng2 $lng1 $lng
do
   F="$LOCALEDIR/$D/LC_MESSAGES/$mo"
   [ -f "$F" ] && . "$F"
done

LANGORG=$LANG

mysplash() {
	LANG=$LANGORG gxmessage -center -wrap -bg orange -title "$_Title" -buttons '' -nofocus "$@" &
	X1PID=$!
}